/*
    Génération de feuille de personnage complète AD&D 1 et 2
    Génération aléatoire de personnage

    Copyright (C) 2011 Bernard SIAUD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Un grand merci à Denis Léger pour sa liste de sort de magicien que j'ai
    récupéré pour compléter la mienne.

    MERCI À Seldnor de http://dnd.ezael.net pour les caractéristiques de AD&D1
*/

#include "include.h"

const gchar * vers[]={"ADD","ADD2","?"};
const gchar * init[]={"f","i","s","d","co","ch","b","h"};
const gchar * nom[]={"Force","Intelligence","Sagesse","Dextérité","Constitution","Charisme","Beauté","Humour","Pourcentage"};
const gchar * nom_min[]={"force","intelligence","sagesse","dexterite","constitution","charisme","beaute","humour","pourcentage"};
const gchar * nom_abr[]={"FOR","INT","SAG","DEX","CON","CHA","BEA","HUM","POU"};
const gchar algnm[9][4]={"BL","BN","BC","NL","NN","NC","ML","MN","MC"};
const gchar * Tirages[]={"3D6_","4D6_","5D6__","6x3D6_","4D5+3_","\0"};
const gchar * nom_sexe[]={"Masculin","Féminin"};
const signed short niveau_RN[]={0,0,0,0,0,0,0,0,0,3,4,5,6,7,8,9,10,11,12}; /* add2 : niveau max des races nouvelles */

const gchar vd_add1[13][14][4]= /* vade retro */
{
    {"10","7","4","T","T","D","D","D*","D*","D*","D*","D*","D*","D*"},
    {"13","10","7","T","T","D","D","D","D*","D*","D*","D*","D*","D*"},
    {"16","13","10","4","T","T","D","D","D","D","D","D","D","D*"},
    {"19","16","13","7","4","T","T","D","D","D","D","D","D","D*"},
    {"20","19","16","10","7","4","T","T","D","D","D","D","D","D"},
    {"-","20","19","13","10","7","4","T","T","T","T","T","T","D"},
    {"-","-","20","16","13","10","7","4","T","T","T","T","T","D"},
    {"-","-","-","20","16","13","10","7","4","4","4","4","4","T"},
    {"-","-","-","-","20","16","13","10","7","7","7","7","7","T"},
    {"-","-","-","-","-","20","16","13","10","10","10","10","10","4"},
    {"-","-","-","-","-","-","20","16","13","13","13","13","13","7"},
    {"-","-","-","-","-","-","-","19","16","16","16","16","16","10"},
    {"-","-","-","-","-","-","-","20","19","19","19","19","19","13"}
};

const gchar vd_add2[13][14][4]= /* vade retro */
{
    {"10","7","4","R","R","D","D","D*","D*","D*","D*","D*","D*","D*"},
    {"13","10","7","4","R","R","D","D","D*","D*","D*","D*","D*","D*"},
    {"16","13","10","7","4","R","R","D","D","D*","D*","D*","D*","D*"},
    {"19","16","13","10","7","4","R","R","D","D","D","D*","D*","D*"},
    {"20","19","16","13","10","7","4","R","R","D","R","D","D","D*"},
    {"-","20","19","16","13","10","7","4","R","R","R","D","D","D*"},
    {"-","-","20","19","16","13","10","7","4","R","R","R","R","D"},
    {"-","-","-","20","19","16","13","10","7","4","4","R","R","R"},
    {"-","-","-","-","20","19","16","13","10","7","7","4","4","R"},
    {"-","-","-","-","-","20","19","16","13","10","10","7","7","4"},
    {"-","-","-","-","-","-","20","19","16","13","13","10","10","7"},
    {"-","-","-","-","-","-","-","20","19","16","16","13","13","10"},
    {"-","-","-","-","-","-","-","-","20","19","19","16","16","13"}
};


//struct_competences * competences;
char ** competences_l1, ** competences_l2;

//struct_armes * armes;
//pant * pantheons;
//struct_armure * armures;


const signed short fac_vol_caract[11][8]={
                          {-15,-10,-10,-20,-10,  0,  0,  0},
                          {-10, -5,-10,-15, -5,  0,  0,  0},
                          { -5,  0, -5,-10,  0,  0,  0,  0},
                          {  0,  0,  0, -5,  0,  0,  0,  0},
                          {  0,  0,  0,  0,  0,  0,  0,  0},
                          {  0,  0,  0,  0,  0,  0,  0,  0},
                          {  0,  0,  0,  0,  0,  0,  0,  0},
                          {  0, +5,  0,  0,  0,  0,  0,  0},
                          { +5,+10,  0, +5, +5,  0,  0,  0},
                          {+10,+15, +5,+10,+10,  0,  0,  0},
                          {+15,+20,+10,+15,+15,  0,  0,  0}
                         };

const gchar * nom_fac_vol[]={"pickpoket","crochetage","reperage","dpl_sil","dis_ombre","ecoute_porte","escalade","lecture","marcher_corde_raide","saut_perche","saut_hauteur","saut_longueur_sans_elan","saut_longueur_elan","man_acrobat_attaque","man_acrobat_evasion","man_acrobat_chute"};
const gchar * nom_fac_voleur[]={
    "Pickpocket",
    "Crochetage\ndes serrures",
    "Repérage\ndésamorçage pièges",
    "Déplacement\nsilencieux",
    "Dissimulation\ndans l'ombre",
    "Écoute\naux portes",
    "Escalade",
    "Lecture\ndes languages",
    "Marcher sur\n une corde raide",
    "Saut à\nla perche",
    "Saut en\nhauteur",
    "Saut en\nlongueur sans élan",
    "Saut en\nlongueur avec élan",
    "Manœuvres\n acrobatiques attaque",
    "Manœuvres\n acrobatiques évasion",
    "Manœuvres\n acrobatiques chute"
};


const gchar tabl_constit[25][5][8]=
{
        {"-3","25%","30%","-2",""},
        {"-2","30%","35%","-1",""},
        {"-2","35%","40%","",""},
        {"-1","40%","45%","",""},
        {"-1","45%","50%","",""},
        {"-1","50%","55%","",""},
        {"","55%","60%","",""},
        {"","60%","65%","",""},
        {"","65%","70%","",""},
        {"","70%","75%","",""},
        {"","75%","80%","",""},
        {"","80%","85%","",""},
        {"","85%","90%","",""},
        {"","88%","92%","",""},
        {"+1","90%","94%","",""},
        {"+2","95%","96%","",""},
        {"+2(+3)","97%","98%","",""},
        {"+2(+4)","99%","100%","",""},
        {"+2(+5)","99%","100%","+1",""},
        {"+2(+5)","99%","100%","+1","1/6T"},
        {"+2(+6)","99%","100%","+2","1/5T"},
        {"+2(+6)","99%","100%","+2","1/4T"},
        {"+2(+6)","99%","100%","+3","1/3T"},
        {"+2(+7)","99%","100%","+3","1/2T"},
        {"+2(+7)","100%","100%","+4","1/1T"}
};

const gchar tabl_inte2[25][5][8]=
{

        {"0","","","",""}, /* 1*/
        {"1","","","",""},
        {"1","","","",""},
        {"1","","","",""},
        {"1","","","",""}, /* 5 */
        {"1","","","",""},
        {"1","","","",""},
        {"1","","","",""},
        {"2","4","35%","6",""},
        {"2","5","40%","7",""}, /* 10 */
        {"2","5","45%","7",""},
        {"3","6","50%","7",""},
        {"3","6","55%","9",""},
        {"4","7","60%","9",""},
        {"4","7","65%","11",""}, /* 15 */
        {"5","8","70%","11",""},
        {"6","8","75%","14",""},
        {"7","9","85%","18",""},
        {"8","9","95%","Tous","Illu 1"},
        {"9","9","96%","Tous","Illu 2"}, /* 20 */
        {"10","9","97%","Tous","Illu 3"},
        {"11","9","98%","Tous","Illu 4"},
        {"12","9","99%","Tous","Illu 5"},
        {"15","9","100%","Tous","Illu 6"},
        {"20","9","100%","Tous","Illu 7"} /* 25 */
};

const gchar tabl_inte1[25][5][8]=
{

        {"0","","","",""}, /* 1*/
        {"0","","","",""},
        {"0","","","",""},
        {"0","","","",""},
        {"0","","","",""}, /* 5 */
        {"0","","","",""},
        {"0","","","",""},
        {"1","","","",""},
        {"1","4","35%","6","4"},
        {"2","5","45%","7","5"}, /* 10 */
        {"2","5","45%","7","5"},
        {"3","6","45%","7","5"},
        {"3","6","55%","9","6"},
        {"4","7","55%","9","6"},
        {"4","7","65%","11","7"}, /* 15 */
        {"5","8","65%","11","7"},
        {"6","8","75%","14","8"},
        {"7","9","85%","18","9"},
        {"8","9","95%","Tous","10"},
        {"9","9","95%","Tous","10"}, /* 20 */
        {"10","9","95%","Tous","10"},
        {"11","9","95%","Tous","10"},
        {"12","9","95%","Tous","10"},
        {"15","9","95%","Tous","10"},
        {"20","9","95%","Tous","10"} /* 25 */
};

/*const gchar tabl_sagesse[25][10][16]=
{

        {"-6","","","","","","","","80%",""},
        {"-4","","","","","","","","60%",""},
        {"-3","","","","","","","","50%",""},
        {"-2","","","","","","","","45%",""},
        {"-1","","","","","","","","40%",""},
        {"-1","","","","","","","","35%",""},
        {"-1","","","","","","","","30%",""},
        {"0","","","","","","","","25%",""},
        {"0","0","0","0","0","0","0","0","20%",""},
        {"0","0","0","0","0","0","0","0","15%",""},
        {"0","0","0","0","0","0","0","0","10%",""},
        {"0","0","0","0","0","0","0","0","5%",""},
        {"0","1","0","0","0","0","0","0","0%",""},
        {"0","2","0","0","0","0","0","0","0%",""},
        {"+1","2","1","0","0","0","0","0","0%",""},
        {"+2","2","2","0","0","0","0","0","0%",""},
        {"+3","2","2","1","0","0","0","0","0%",""},
        {"+4","2","2","1","1","0","0","0","0%",""},
        {"+4","3","2","1","2","0","0","0","0%","1"},
        {"+4","3","3","1","3","0","0","0","0%","1+2"},
        {"+4","3","3","2","3","1","0","0","0%","1+2+3"},
        {"+4","3","3","2","4","2","0","0","0%","1+2+3+4"},
        {"+4","3","3","2","4","4","0","0","0%","1+2+3+4+5"},
        {"+4","3","3","2","4","4","2","0","0%","1+2+3+4+5+6"},
        {"+4","3","3","2","4","4","3","1","0%","1+2+3+4+5+6+7"}
};*/ /* AdDD + AD&D2 => incohérance à 19  de sagesse */


const gchar tabl_sagesse[25][10][16]=
{

        {"-6","","","","","","","","80%",""},
        {"-4","","","","","","","","60%",""},
        {"-3","","","","","","","","50%",""},
        {"-2","","","","","","","","45%",""},
        {"-1","","","","","","","","40%",""},
        {"-1","","","","","","","","35%",""},
        {"-1","","","","","","","","30%",""},
        {"0","","","","","","","","25%",""},
        {"0","0","0","0","0","0","0","0","20%",""},
        {"0","0","0","0","0","0","0","0","15%",""},
        {"0","0","0","0","0","0","0","0","10%",""},
        {"0","0","0","0","0","0","0","0","5%",""},
        {"0","1","0","0","0","0","0","0","0%",""},
        {"0","2","0","0","0","0","0","0","0%",""},
        {"+1","2","1","0","0","0","0","0","0%",""},
        {"+2","2","2","0","0","0","0","0","0%",""},
        {"+3","2","2","1","0","0","0","0","0%",""},
        {"+4","2","2","1","1","0","0","0","0%",""},
        {"+4","3","2","2","1","0","0","0","0%","1"},
        {"+4","3","3","2","2","0","0","0","0%","1+2"},
        {"+4","3","3","3","2","1","0","0","0%","1+2+3"},
        {"+4","3","3","3","3","2","0","0","0%","1+2+3+4"},
        {"+4","4","3","3","3","2","1","0","0%","1+2+3+4+5"},
        {"+4","4","3","3","3","3","2","0","0%","1+2+3+4+5+6"},
        {"+4","4","3","3","3","3","3","1","0%","1+2+3+4+5+6+7"}
}; /* AD&D 2.5 => correction à 19 et 23 de sagesse */

const gchar tabl_dexterite[25][3][4]=
{
    {"-6","-6","+5"}, /* 1*/
    {"-4","-4","+5"},
    {"-3","-3","+4"},
    {"-2","-2","+3"},
    {"-1","-1","+2"}, /* 5 */
    {"","","+1"},
    {"","",""},
    {"","",""},
    {"","",""},
    {"","",""}, /* 10 */
    {"","",""},
    {"","",""},
    {"","",""},
    {"","",""},
    {"","","-1"}, /* 15 */
    {"+1","+1","-2"},
    {"+2","+2","-3"},
    {"+3","+3","-4"},
    {"+3","+3","-4"},
    {"+3","+3","-4"}, /* 20 */
    {"+4","+4","-5"},
    {"+4","+4","-5"},
    {"+4","+4","-5"},
    {"+5","+5","-6"},
    {"+5","+5","-6"} /* 25 */
};

const unsigned short c_poids_taille[80][2]=
{
    {	110	,	625	}	,
    {	109	,	608	}	,
    {	108	,	592	}	,
    {	107	,	575	}	,
    {	106	,	559	}	,
    {	105	,	544	}	,
    {	104	,	528	}	,
    {	103	,	513	}	,
    {	102	,	498	}	,
    {	101	,	484	}	,
    {	100	,	470	}	,
    {	99	,	456	}	,
    {	98	,	442	}	,
    {	97	,	429	}	,
    {	96	,	415	}	,
    {	95	,	403	}	,
    {	94	,	390	}	,
    {	93	,	378	}	,
    {	92	,	366	}	,
    {	91	,	354	}	,
    {	90	,	342	}	,
    {	89	,	331	}	,
    {	88	,	320	}	,
    {	87	,	309	}	,
    {	86	,	299	}	,
    {	85	,	288	}	,
    {	84	,	278	}	,
    {	83	,	268	}	,
    {	82	,	259	}	,
    {	81	,	250	}	,
    {	80	,	240	}	,
    {	79	,	232	}	,
    {	78	,	223	}	,
    {	77	,	214	}	,
    {	76	,	206	}	,
    {	75	,	198	}	,
    {	74	,	190	}	,
    {	73	,	183	}	,
    {	72	,	175	}	,
    {	71	,	168	}	,
    {	70	,	161	}	,
    {	69	,	154	}	,
    {	68	,	148	}	,
    {	67	,	141	}	,
    {	66	,	135	}	,
    {	65	,	129	}	,
    {	64	,	123	}	,
    {	63	,	117	}	,
    {	62	,	112	}	,
    {	61	,	107	}	,
    {	60	,	101	}	,
    {	59	,	96	}	,
    {	58	,	92	}	,
    {	57	,	87	}	,
    {	56	,	82	}	,
    {	55	,	78	}	,
    {	54	,	74	}	,
    {	53	,	70	}	,
    {	52	,	66	}	,
    {	51	,	62	}	,
    {	50	,	59	}	,
    {	49	,	55	}	,
    {	48	,	52	}	,
    {	47	,	49	}	,
    {	46	,	46	}	,
    {	45	,	43	}	,
    {	44	,	40	}	,
    {	43	,	37	}	,
    {	42	,	35	}	,
    {	41	,	32	}	,
    {	40	,	30	}	,
    {	39	,	28	}	,
    {	38	,	26	}	,
    {	37	,	24	}	,
    {	36	,	22	}	,
    {	35	,	20	}	,
    {	34	,	18	}	,
    {	33	,	17	}	,
    {	32	,	15	}	,
    {	31	,	14	}
};

const signed short v_poids_taille[9]={6	,26	,151	,351	,651	,851	,976	,996	, -1}; /* affichage de 000 pour la valeur -1 au dernier */

const float force_taille[16]={-0.09	,-0.06	,-0.03	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.03	,0.06	,0.09	};

const float force_poids[16]={-0.200	,-0.160	,-0.120	,-0.080	,-0.040	,0.00	,0.00	,0.00	,0.00	,0.00	,0.00	,0.040	,0.080	,0.120	,0.160	,0.200	};

const gint hiatus[9][20]=
{
    {-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1 ,1, 1, 1},
    {-1,-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
    {-2,-1,-1,-1,-1,-1,-1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 2},
    {-2,-2,-1,-1,-1,-1,-1,-1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 2, 2},
    {-3,-2,-2,-1,-1,-1,-1,-1,-1, 0, 0, 1, 1, 1, 1, 1, 1, 2, 2, 3},
    {-3,-3,-2,-2,-2,-1,-1,-1,-1, 0, 0, 1, 1, 1, 1, 2, 2, 2, 3, 3},
    {-4,-3,-3,-2,-2,-1,-1,-1,-1, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 4},
    {-4,-4,-3,-3,-2,-2,-1,-1,-1, 0, 0, 1, 1, 1, 2, 2, 3, 3, 4, 4},
    {-5,-4,-4,-3,-3,-2,-2,-1,-1, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5}
};
                                    /*       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 */
const signed short add_niv_max_maitre[26]=  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,4,4,4,4,4,4,4};
const signed short add_niv_max_saurial[26]= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1};
const signed short add_niv_max_humanoide[4]={0,1,2,3};
const signed short add_niv_max_demi_hum[4] ={0,1,4,7};
